/*! modernizr 3.3.1 (Custom Build) | MIT *
 * http://modernizr.com/download/?-prefixed !*/
!function(e,n,t){function r(e,n){return typeof e===n}function o(){var e,n,t,o,i,s,f;for(var u in v)if(v.hasOwnProperty(u)){if(e=[],n=v[u],n.name&&(e.push(n.name.toLowerCase()),n.options&&n.options.aliases&&n.options.aliases.length))for(t=0;t<n.options.aliases.length;t++)e.push(n.options.aliases[t].toLowerCase());for(o=r(n.fn,"function")?n.fn():n.fn,i=0;i<e.length;i++)s=e[i],f=s.split("."),1===f.length?Modernizr[f[0]]=o:(!Modernizr[f[0]]||Modernizr[f[0]]instanceof Boolean||(Modernizr[f[0]]=new Boolean(Modernizr[f[0]])),Modernizr[f[0]][f[1]]=o),g.push((o?"":"no-")+f.join("-"))}}function i(e){return e.replace(/([a-z])-([a-z])/g,function(e,n,t){return n+t.toUpperCase()}).replace(/^-/,"")}function s(e,n){return!!~(""+e).indexOf(n)}function f(e,n){return function(){return e.apply(n,arguments)}}function u(e,n,t){var o;for(var i in e)if(e[i]in n)return t===!1?e[i]:(o=n[e[i]],r(o,"function")?f(o,t||n):o);return!1}function a(e){return e.replace(/([A-Z])/g,function(e,n){return"-"+n.toLowerCase()}).replace(/^ms-/,"-ms-")}function l(){return"function"!=typeof n.createElement?n.createElement(arguments[0]):E?n.createElementNS.call(n,"http://www.w3.org/2000/svg",arguments[0]):n.createElement.apply(n,arguments)}function p(){var e=n.body;return e||(e=l(E?"svg":"body"),e.fake=!0),e}function d(e,t,r,o){var i,s,f,u,a="modernizr",d=l("div"),c=p();if(parseInt(r,10))for(;r--;)f=l("div"),f.id=o?o[r]:a+(r+1),d.appendChild(f);return i=l("style"),i.type="text/css",i.id="s"+a,(c.fake?c:d).appendChild(i),c.appendChild(d),i.styleSheet?i.styleSheet.cssText=e:i.appendChild(n.createTextNode(e)),d.id=a,c.fake&&(c.style.background="",c.style.overflow="hidden",u=S.style.overflow,S.style.overflow="hidden",S.appendChild(c)),s=t(d,e),c.fake?(c.parentNode.removeChild(c),S.style.overflow=u,S.offsetHeight):d.parentNode.removeChild(d),!!s}function c(n,r){var o=n.length;if("CSS"in e&&"supports"in e.CSS){for(;o--;)if(e.CSS.supports(a(n[o]),r))return!0;return!1}if("CSSSupportsRule"in e){for(var i=[];o--;)i.push("("+a(n[o])+":"+r+")");return i=i.join(" or "),d("@supports ("+i+") { #modernizr { position: absolute; } }",function(e){return"absolute"==getComputedStyle(e,null).position})}return t}function m(e,n,o,f){function u(){p&&(delete b.style,delete b.modElem)}if(f=r(f,"undefined")?!1:f,!r(o,"undefined")){var a=c(e,o);if(!r(a,"undefined"))return a}for(var p,d,m,h,v,y=["modernizr","tspan"];!b.style;)p=!0,b.modElem=l(y.shift()),b.style=b.modElem.style;for(m=e.length,d=0;m>d;d++)if(h=e[d],v=b.style[h],s(h,"-")&&(h=i(h)),b.style[h]!==t){if(f||r(o,"undefined"))return u(),"pfx"==n?h:!0;try{b.style[h]=o}catch(g){}if(b.style[h]!=v)return u(),"pfx"==n?h:!0}return u(),!1}function h(e,n,t,o,i){var s=e.charAt(0).toUpperCase()+e.slice(1),f=(e+" "+w.join(s+" ")+s).split(" ");return r(n,"string")||r(n,"undefined")?m(f,n,o,i):(f=(e+" "+_.join(s+" ")+s).split(" "),u(f,n,t))}var v=[],y={_version:"3.3.1",_config:{classPrefix:"",enableClasses:!0,enableJSClass:!0,usePrefixes:!0},_q:[],on:function(e,n){var t=this;setTimeout(function(){n(t[e])},0)},addTest:function(e,n,t){v.push({name:e,fn:n,options:t})},addAsyncTest:function(e){v.push({name:null,fn:e})}},Modernizr=function(){};Modernizr.prototype=y,Modernizr=new Modernizr;var g=[],C="Moz O ms Webkit",w=y._config.usePrefixes?C.split(" "):[];y._cssomPrefixes=w;var x=function(n){var r,o=prefixes.length,i=e.CSSRule;if("undefined"==typeof i)return t;if(!n)return!1;if(n=n.replace(/^@/,""),r=n.replace(/-/g,"_").toUpperCase()+"_RULE",r in i)return"@"+n;for(var s=0;o>s;s++){var f=prefixes[s],u=f.toUpperCase()+"_"+r;if(u in i)return"@-"+f.toLowerCase()+"-"+n}return!1};y.atRule=x;var _=y._config.usePrefixes?C.toLowerCase().split(" "):[];y._domPrefixes=_;var S=n.documentElement,E="svg"===S.nodeName.toLowerCase(),z={elem:l("modernizr")};Modernizr._q.push(function(){delete z.elem});var b={style:z.elem.style};Modernizr._q.unshift(function(){delete b.style}),y.testAllProps=h;y.prefixed=function(e,n,t){return 0===e.indexOf("@")?x(e):(-1!=e.indexOf("-")&&(e=i(e)),n?h(e,n,t):h(e,"pfx"))};o(),delete y.addTest,delete y.addAsyncTest;for(var P=0;P<Modernizr._q.length;P++)Modernizr._q[P]();e.Modernizr=Modernizr}(window,document);

(function() {
  /**
   * Decimal adjustment of a number.
   *
   * @param {String}  type  The type of adjustment.
   * @param {Number}  value The number.
   * @param {Integer} exp   The exponent (the 10 logarithm of the adjustment base).
   * @returns {Number} The adjusted value.
   */
  function decimalAdjust(type, value, exp) {
    // If the exp is undefined or zero...
    if (typeof exp === 'undefined' || +exp === 0) {
      return Math[type](value);
    }
    value = +value;
    exp = +exp;
    // If the value is not a number or the exp is not an integer...
    if (isNaN(value) || !(typeof exp === 'number' && exp % 1 === 0)) {
      return NaN;
    }
    // Shift
    value = value.toString().split('e');
    value = Math[type](+(value[0] + 'e' + (value[1] ? (+value[1] - exp) : -exp)));
    // Shift back
    value = value.toString().split('e');
    return +(value[0] + 'e' + (value[1] ? (+value[1] + exp) : exp));
  }

  // Decimal round
  if (!Math.round10) {
    Math.round10 = function(value, exp) {
      return decimalAdjust('round', value, exp);
    };
  }
  // Decimal floor
  if (!Math.floor10) {
    Math.floor10 = function(value, exp) {
      return decimalAdjust('floor', value, exp);
    };
  }
  // Decimal ceil
  if (!Math.ceil10) {
    Math.ceil10 = function(value, exp) {
      return decimalAdjust('ceil', value, exp);
    };
  }
})();

var app = {
    // Application Constructor
    initialize: function() {
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
    }
};

var DefaultGameSettings = {
    language: 'HU'
,   vibrate: true
,   background: 'wood'
,   showShortDescription: true
};
var CurrentGameSettings = {};
var settingsAdapter;

var GameStats = {
    tiszavirag: {
        totalGamesPlayed: 0
    ,   totalGamesWon: 0
    ,   gameWinRate: 0
    ,   totalGameLength: 0
    ,   averageGameLength: 0
    ,   shortestGameLength: Number.MAX_VALUE
    },
    strategia: {
        totalGamesPlayed: 0
    ,   totalGamesWon: 0
    ,   gameWinRate: 0
    ,   totalGameLength: 0
    ,   averageGameLength: 0
    ,   shortestGameLength: Number.MAX_VALUE
    }
};
var CurrentGameStats = {};
var statsAdapter;

(function() {
    settingsAdapter = Lawnchair({name:'pasziansz',adapter:'dom'}, function() {
    });

    for (var i in DefaultGameSettings) {
        settingsAdapter.exists(i, function(exists) {
            if (!exists) {
                settingsAdapter.save({key: i, value: DefaultGameSettings[i]});
            }
        });
    }
    settingsAdapter.each(function(obj, index) {
        CurrentGameSettings[obj.key] = obj.value;
    });

    statsAdapter = Lawnchair({name:'pasziansz-stats',adapter:'dom'}, function() {
    });

    for (var i in GameStats) {
        statsAdapter.exists(i, function(exists) {
            if (!exists) {
                statsAdapter.save({key: i, value: GameStats[i]});
            }
        });
    }
    statsAdapter.each(function(obj, index) {
        CurrentGameStats[obj.key] = obj.value;
    });
})();

var saveSettings = function(settingsObject, callback) {
    var settingsArray = [];
    for (var i in settingsObject) {
        settingsArray.push({key: i, value: settingsObject[i]});
    }
    settingsAdapter.batch(settingsArray, function() {
        if (typeof callback === 'function') {
            callback();
        }
    });
};

var saveStats = function(game, statsObject, callback) {
    statsAdapter.save({ key: game, value: statsObject }, function() {
        if (typeof callback === 'function') {
            callback();
        }
    });
};
