$(function() {

    var $settings = CurrentGameSettings;
    var $data = {
        messages: null
    };

    var $selectors = {
        body: 'body'
    };
    var $cssClasses = {
    };
    var $elements = {
        body: $($selectors.body)
    };
    var $templates = {};
    $('script[type="text/template"]').each(function() { $templates[this.id] = $(this).html(); })

    var $methods = {
        translateMessages: function() {
            $('[data-i18n]').each(function() {
                $(this).html($(this).attr('data-'+$settings.language));
            });
        },
        setupBackground: function() {
            $elements.body.attr('data-texture', $settings.background);
        }
    };
    var $events = {
        revealDemoScreen: function() {
            $methods.translateMessages();
            $methods.setupBackground();
        }
    };

    $events.revealDemoScreen();

    document.addEventListener("backbutton", function() {
        window.location = 'index.html'
    }, false)    
});
